#version 430 core

in vec4 worldPosition;
in vec3 worldNormal;
in mat4 inverseView;

in vec2 fragmentUV;

in vec4 smCoords;

layout (location=0) out vec4 fragColor;
layout (location=1) out vec4 glowColor;

layout(binding=0) uniform sampler2D color_texture;
layout(binding=1) uniform sampler2D glow_texture;
//layout(binding = 2) uniform sampler2D shadowMap;
layout(binding=2) uniform sampler2DShadow shadowMap;

uniform float ambient;
uniform float shininess;
uniform vec3 specularColor;
uniform vec3 sunColor;
uniform vec3 sunDirection;

void main() {
	/*
	vec2 sm_uvs = smCoords.xy / smCoords.w;
	float depth_p = smCoords.z / smCoords.w;
	float depth_c = texture(shadowMap, sm_uvs).r;
	float shadowMult = (depth_c < depth_p) ? 0.2 : 1.0; // in shadow : in light
	*/
	/* automatically divides by .w */
	float shadowMult = textureProj(shadowMap, smCoords);
	shadowMult = max(0.3, shadowMult);

	vec3 specular = vec3(0);
	vec3 normal = normalize(worldNormal);
	vec3 viewDirection = normalize(vec3(inverseView * vec4(0.0, 0.0, 0.0, 1.0) - worldPosition));

	vec4 textureColor = texture(color_texture, fragmentUV);
	//fragColor = vec4((worldNormal + 1) / 2 *lightAmount, 1.0);
	
	float diffuse = max(0, dot(-sunDirection, normal));
	// specular reflection
	if(diffuse > 0) {
		vec3 H = normalize(-sunDirection + viewDirection);
		specular = specularColor * pow(max(0,dot(normal, H)), shininess);
	}

	glowColor = texture(glow_texture, fragmentUV);
	if(glowColor == vec4(0)){
		fragColor = vec4(textureColor.rgb * shadowMult * sunColor * (ambient + diffuse) + specular, textureColor.a);
	}
	else {
		fragColor = textureColor;
	}

	

	//fragColor = vec4(texture(shadowMap, fragmentUV).rrr, 1.0);
	//fragColor = vec4(depth_c,depth_c,depth_c,1.0);
}